﻿//ALL CLASSES NEED THIS
package{
	//WE NEED THESE IMPORTED FOR THE PROGRAM TO RUN
	import flash.display.MovieClip;
	import flash.events.*;
	
	//THIS MAKES EACH POWERUP ACT AS A MOVIECLIP
	public class Double extends MovieClip{
	
		//VARIABLES
		
		//Defining _root for use as the root of the game
		private var _root:Object;
		//SPEED OF THE FALLING POWERUP
		private var speed:int = 10;
		
		//THIS WILL RUN FOR EVERY POWERUP ADDED TO THE GAME
		public function Double(){
			//ADDING EVENT THAT WILL ONLY RUN ONCE
			// (WHEN THE OBJECT IS ADDED)
			addEventListener(Event.ADDED, beginClass);
			
			//EVENT THAT WILL RUN EVERY FRAME
			addEventListener(Event.ENTER_FRAME, eFrame);
		}
		
		
		//SETTING _root AS THE ROOT
		private function beginClass(event:Event):void{
			_root = MovieClip(root);
		}
		
		
		//ON EVERY FRAME
		private function eFrame(event:Event):void{
		
			//MOVE THE OBJECT DOWN THE SCREEN BY ITS SPEED
			y += speed;
			
			//REMOVE IT IF IT GOES OFFSTAGE
			if(this.y > stage.stageHeight){
				//REMOVE LISTENERS
				removeEventListener(Event.ENTER_FRAME, eFrame);				
				//REMOVE SELF FROM STAGE
				_root.removeChild(this);
			}
			
			
			
			//HIT TEST WITH PLAYER
			if(hitTestObject(_root.mcMain)){
				//_root.hitChannel=_root.snd3.play();
				//TELL GAME SHOTS ARE DOUBLES
				_root.doubleOn = true;
				_root.doubleTime = _root.doubleMax;
				//REMOVE LISTENERS
				removeEventListener(Event.ENTER_FRAME, eFrame);
				//REMOVE SELF FROM STAGE
				_root.removeChild(this);
			}
			
			
			//CHECK FOR GAMEOVER
			if (_root.gameOver) {
				//REMOVE LISTENERS
				removeEventListener(Event.ENTER_FRAME, eFrame);
				//REMOVE SELF FROM STAGE
				this.parent.removeChild(this);
			}
		}
		
		//HOW TO REMOVE LISTENERS WITH A SHORT CALL
		public function removeListeners():void {
			this.removeEventListener(Event.ENTER_FRAME, eFrame);
		}
	}
}